
#include "stdafx.h" // <-- usunc dla Borlanda !!!!

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// staa okrelajca naw pliku do wczytywania
#define FILE_NAME_2_READ	"D:\\jd\\odczyt\\dane.txt"


// trim w C
char* str_trim (char *s ) {
    
	char *p = s;

	// usunicie spacji od koca
    while( *p ) {
		p++;
	}
    
	p--;

    while( *p == ' ' ) {
		p--;
	}
    
    *++p = 0;

	// i z pocztku
	p = s;
    while( *p == ' ' ) {
		p++;
	}
    return ( p );
}



//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// na podstawie strony
// http://geta.life.uiuc.edu/~gary/programs/CRITICA/critica105b/Array.c
//
typedef struct {
  int elements;
  int maxSize;
  int dirty;
  void **array;
} TArrayStruct;

typedef TArrayStruct*	TArray;

// inicjacja nowej tablicy
TArray newArray (int maxSize) {
	TArray array = (TArray) malloc (sizeof (TArrayStruct));

	if (array == NULL) {
		printf ("newArray - bd alokacji pamieci\n");
		exit (1);
	}
	else {
		array->maxSize = maxSize;
		array->elements = 0;
		array->dirty = 0;
		array->array = (void **) calloc (maxSize, sizeof (void *));
		if (array->array == NULL) {
			printf ("newArray - bd realokacji pamici\n");
		exit (1);
		}
	}
	return ( array );
}

// dodawanie elementu do wskazanej tablicy
void addToArray (TArray array, void *element) {
  array->array[ array->elements++ ] = element;
  array->dirty = 1;
  if ( array->elements == array->maxSize ) {
    array->maxSize *= 2;
    array->array = (void **)realloc (
							array->array, 
							array->maxSize * sizeof (void*)
						);
    if ( array->array == NULL ) {
      printf ("addToArray - bd alokacji podczas dodawania elementu\n");
      exit (1);
    }
  }
}

void freeArray (TArray array, void (*freefunc) (void *)) {

	int i;

  for ( i = 0; i < array->elements; i++ ) {
		freefunc ( array->array[i] );
  }
  free ( array->array );
  free ( array );
}

// alokacja pamici pod nowy element zadanego typu, tu: double
double* copyDouble (double d) {
	double *copy = (double*)malloc (sizeof (double));
	*copy = d;
	return ( copy );
}

// a tu TArray
TArray* copyArray (TArray a) {
	TArray *copy = (TArray*)malloc (sizeof (TArray));
	*copy = a;
	return ( copy );
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// dostawianie rzdka z danymi
void AppendDataRow ( char *pszLine , TArray destArray ) {

	// deklarujemmy nowy rzdek w tabelce
	TArray newDataRow = newArray ( 1 );
	
	// zmienna pomocnicza
	char *pExit;

	// strtok to funkcja pozwalajca podzieli napis (bufor znakw)
	// na mniejsze kawaki, na podstawie zadanego separatora,
	// w tym przypadku spacji
	// szukamy pierwszego elementu
	char *pItem = strtok ( pszLine, " " );
	// i w petli nastepnych
	while ( pItem != NULL ) {
		// zmienna pomocnicza, aby usun spacje przed i po
		char *pS = str_trim( pItem );
		// jeeli wyszed z tego niepusty string
		if ( strlen ( pS ) != 0 ) {
			// konwertujemy go do zmiennej typu double
			double dbl = strtod ( pS, &pExit ); 
			// i wstawiamy do wasnie budowanego rzdka tabeli
			addToArray( newDataRow, copyDouble ( dbl ) );
		}
		// szukamy nastpnego elementu (liczby) w linii
		pItem = strtok ( NULL, " " );
	}
	// dodajemy cay rzdek do wynikowej tabeli
	addToArray ( destArray, copyArray( newDataRow ) );
}


// zwraca element identyfikowny przez R,C z tabelki A
double getElementAt (TArray a, int r, int c ) {
	if ( r > a->elements ) {
		printf ("parameter R poza zakresem!\n");
		exit ( 0 );
	}
	TArray	pRow = *(TArray*)a->array[ r ];
	if ( c > pRow->elements ) {
		printf ( "parametr C poza zakresem!\n");
		exit ( 0 );
	}
	
	return ( *(double*)pRow->array [ c ] );
}

// funkcja gwna
int main(int argc, char* argv[]) {

	// kontener na dane - TArray of TArray czyli "macierz" 
	TArray dataRows = newArray ( 1 );

	//otwarcie pliku 
	FILE *pF = fopen ( FILE_NAME_2_READ, "rt" /* tylko odczyt, jako tekst*/);
	// jeeli si otwarcie nie uda - wyjcie
	if ( pF == NULL ) {
		printf ( "err\n" );
		return ( 0 );
	}

	//skan po rekordach z danymi, a do koca pliku czyli znacznika EOF
	while ( !feof( pF ) ) {

		// deklarujemy pomocniczy bufor na znaczki
		char szT [ 0xFF ];
		// profilaktycznie robimy z niego pusty string
		szT [ 0 ] = 0;
		
		//odczytujemy jedn lini
		fgets ( szT, 0xFF, pF );
		// sprawdzamy czy zawiera co poza spacjami i 
		// jeeli niepusta linia to...
		char *pL = str_trim( szT );
		if ( strlen( pL ) != 0 ) {
			// dostawianie nowych danych
			AppendDataRow ( pL , dataRows );
		}
	}
	// zamknicie pliku
	fclose ( pF );

	// zrzutka danych....
	for (int r = 0; r < dataRows->elements; r++ ) {
		// pobranie jednego rzdku
		TArray oneRow = *(TArray*)dataRows->array[ r ];
		for (int c = 0; c < oneRow->elements; c++ ) {
			double number = getElementAt ( dataRows, r, c );
			printf ("%e ", number );
		}
		printf ( "\n" );
	}

	return ( 0 );
}
